@echo off

:: ---------------------------------------------------------------------------
:: Settings

set MuiFileName=winhlp32.exe.mui
set ExeFileName=winhlp32.exe

:: ---------------------------------------------------------------------------
:: Displaying installer information

echo Ŀ
echo  Windows Help program (WinHlp32) installer for Windows 10.0                 
echo  Vydanie 4                                                                  
echo  Aug 10, 2015                                                               
echo 
echo.

:: ---------------------------------------------------------------------------
:: Windows version detection

echo Setup is detecting Windows version...
ver | findstr /il "10\." > nul
if %errorlevel% equ 0 (
  echo Microsoft Windows 10.0 detected.
  set WindowsVersion=10
  goto :BypassVersionError
)

echo Nezodpovedajca verzia Windows. Intalcia je mon pre verzie:
echo.
echo * Microsoft Windows 10
echo 
pause
goto :eof
:: Mandatory for older Windows versions incapable of understanding EOF,
:: eventhough they don't take CMD files as BAT.
exit

:: ---------------------------------------------------------------------------
:: Initialization

:BypassVersionError
echo %WindowsVersion%
if not %WindowsVersion% GEQ 6 (
  echo Nezodpovedajca verzia Windows. Intalcia je mon pre verzie:
  echo.
  echo * Microsoft Windows 10
  echo 
  pause
  goto :eof
)

:: Preserve current directory for further referrings.
set InitialDirectory=%cd%
:: Change drive and path to where the batch file was started from. This is
:: required when your batch file is run-as-administrator, because it sets
:: System32 the working (current) directory.
cd /d "%0\.."

:: ---------------------------------------------------------------------------
:: Windows 10
 
:InstallFor10
echo.
echo Terminating all possible running instances of WinHlp32...
taskkill /f /im %ExeFileName% /t
:: No error checking is required, becasue if it's not opened so far, an error will occur.
echo.

echo Taking the ownership of system's existing %MuiFileName%...
takeown /f "%SystemRoot%\en-US\%MuiFileName%"
echo.
echo Granting %UserName% full-access permission to system's existing %MuiFileName%...
icacls "%SystemRoot%\en-US\%MuiFileName%" /grant "%UserName%":F
echo.
echo Copying %MuiFileName% to system...
xcopy /r /y /h /q %MuiFileName% "%SystemRoot%\en-US"
echo.
if errorlevel 1 goto :Error

echo Taking the ownership of system's existing %ExeFileName%...
takeown /f "%SystemRoot%\%ExeFileName%"
echo.
echo Granting %UserName% full-access permission to system's existing %ExeFileName%...
icacls "%SystemRoot%\%ExeFileName%" /grant "%UserName%":F
echo.
echo Copying %ExeFileName% to system...
xcopy /r /y /h /q %ExeFileName% "%SystemRoot%"
echo.
if errorlevel 1 goto :Error

echo Updating Registry entries...
reg add "HKLM\SOFTWARE\Microsoft\WinHelp" /v "AllowProgrammaticMacros" /t REG_DWORD /d "0x00000001" /f
reg add "HKLM\SOFTWARE\Microsoft\WinHelp" /v "AllowIntranetAccess" /t REG_DWORD /d "0x00000001" /f
if %PROCESSOR_ARCHITECTURE%==AMD64 (
  reg add "HKLM\SOFTWARE\Wow6432Node\Microsoft\WinHelp" /v "AllowProgrammaticMacros" /t REG_DWORD /d "0x00000001" /f
  reg add "HKLM\SOFTWARE\Wow6432Node\Microsoft\WinHelp" /v "AllowIntranetAccess" /t REG_DWORD /d "0x00000001" /f
)
echo.
if errorlevel 1 goto :Error

pause
goto :eof

:: ---------------------------------------------------------------------------
:: Error management

:Error
echo Chyba pri intalcii WinHlp32
echo.
echo Intalcia sa ukon.
echo 
pause
goto :eof
